namespace BizTalkDateTimeApp.Schemas {
    using Microsoft.XLANGs.BaseTypes;
    
    
    [global::System.CodeDom.Compiler.GeneratedCodeAttribute("Microsoft.BizTalk.Schema.Compiler", "3.0.1.0")]
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
    [global::System.Runtime.CompilerServices.CompilerGeneratedAttribute()]
    [SchemaType(SchemaTypeEnum.Document)]
    [Schema(@"http://BizTalkDateTimeApp.Order",@"Order")]
    [Microsoft.XLANGs.BaseTypes.DistinguishedFieldAttribute(typeof(System.DateTime), "ProviderTime", XPath = @"/*[local-name()='Order' and namespace-uri()='http://BizTalkDateTimeApp.Order']/*[local-name()='ProviderTime' and namespace-uri()='http://BizTalkDateTimeApp.Order']", XsdType = @"dateTime")]
    [Microsoft.XLANGs.BaseTypes.DistinguishedFieldAttribute(typeof(System.DateTime), "UTCTime", XPath = @"/*[local-name()='Order' and namespace-uri()='http://BizTalkDateTimeApp.Order']/*[local-name()='UTCTime' and namespace-uri()='http://BizTalkDateTimeApp.Order']", XsdType = @"dateTime")]
    [Microsoft.XLANGs.BaseTypes.DistinguishedFieldAttribute(typeof(System.DateTime), "BizTalkServerTime", XPath = @"/*[local-name()='Order' and namespace-uri()='http://BizTalkDateTimeApp.Order']/*[local-name()='BizTalkServerTime' and namespace-uri()='http://BizTalkDateTimeApp.Order']", XsdType = @"dateTime")]
    [Microsoft.XLANGs.BaseTypes.PropertyAttribute(typeof(global::BizTalkDateTimeApp.Schemas.OrderDate), XPath = @"/*[local-name()='Order' and namespace-uri()='http://BizTalkDateTimeApp.Order']/*[local-name()='ProviderTimePromoted' and namespace-uri()='http://BizTalkDateTimeApp.Order']", XsdType = @"dateTime")]
    [System.SerializableAttribute()]
    [SchemaRoots(new string[] {@"Order"})]
    [Microsoft.XLANGs.BaseTypes.SchemaReference(@"BizTalkDateTimeApp.Schemas.MyPropertySchema", typeof(global::BizTalkDateTimeApp.Schemas.MyPropertySchema))]
    public sealed class Order : Microsoft.XLANGs.BaseTypes.SchemaBase {
        
        [System.NonSerializedAttribute()]
        private static object _rawSchema;
        
        [System.NonSerializedAttribute()]
        private const string _strSchema = @"<?xml version=""1.0"" encoding=""utf-16""?>
<xs:schema xmlns=""http://BizTalkDateTimeApp.Order"" xmlns:b=""http://schemas.microsoft.com/BizTalk/2003"" xmlns:pp=""https://BizTalkDateTimeApp.MyPropertySchema"" elementFormDefault=""qualified"" targetNamespace=""http://BizTalkDateTimeApp.Order"" xmlns:xs=""http://www.w3.org/2001/XMLSchema"">
  <xs:annotation>
    <xs:appinfo>
      <b:imports>
        <b:namespace prefix=""pp"" uri=""https://BizTalkDateTimeApp.MyPropertySchema"" location=""BizTalkDateTimeApp.Schemas.MyPropertySchema"" />
      </b:imports>
    </xs:appinfo>
  </xs:annotation>
  <xs:element name=""Order"">
    <xs:annotation>
      <xs:appinfo>
        <b:properties>
          <b:property distinguished=""true"" xpath=""/*[local-name()='Order' and namespace-uri()='http://BizTalkDateTimeApp.Order']/*[local-name()='ProviderTime' and namespace-uri()='http://BizTalkDateTimeApp.Order']"" />
          <b:property distinguished=""true"" xpath=""/*[local-name()='Order' and namespace-uri()='http://BizTalkDateTimeApp.Order']/*[local-name()='UTCTime' and namespace-uri()='http://BizTalkDateTimeApp.Order']"" />
          <b:property distinguished=""true"" xpath=""/*[local-name()='Order' and namespace-uri()='http://BizTalkDateTimeApp.Order']/*[local-name()='BizTalkServerTime' and namespace-uri()='http://BizTalkDateTimeApp.Order']"" />
          <b:property name=""pp:OrderDate"" xpath=""/*[local-name()='Order' and namespace-uri()='http://BizTalkDateTimeApp.Order']/*[local-name()='ProviderTimePromoted' and namespace-uri()='http://BizTalkDateTimeApp.Order']"" />
        </b:properties>
      </xs:appinfo>
    </xs:annotation>
    <xs:complexType>
      <xs:sequence>
        <xs:element name=""OrderId"" type=""xs:string"" />
        <xs:element name=""Item"">
          <xs:complexType>
            <xs:sequence>
              <xs:element name=""Name"" type=""xs:string"" />
              <xs:element name=""Price"" type=""xs:decimal"" />
              <xs:element name=""Quantity"" type=""xs:integer"" />
            </xs:sequence>
          </xs:complexType>
        </xs:element>
        <xs:element name=""ProviderTime"" type=""xs:dateTime"" />
        <xs:element name=""UTCTime"" type=""xs:dateTime"" />
        <xs:element name=""BizTalkServerTime"" type=""xs:dateTime"" />
        <xs:element name=""ProviderTimePromoted"" type=""xs:dateTime"" />
      </xs:sequence>
    </xs:complexType>
  </xs:element>
</xs:schema>";
        
        public Order() {
        }
        
        public override string XmlContent {
            get {
                return _strSchema;
            }
        }
        
        public override string[] RootNodes {
            get {
                string[] _RootElements = new string [1];
                _RootElements[0] = "Order";
                return _RootElements;
            }
        }
        
        protected override object RawSchema {
            get {
                return _rawSchema;
            }
            set {
                _rawSchema = value;
            }
        }
    }
}
