
#pragma warning disable 162

namespace BizTalkDateTimeApp
{

    [Microsoft.XLANGs.BaseTypes.PortTypeOperationAttribute(
        "ReceiveOrder",
        new System.Type[]{
            typeof(BizTalkDateTimeApp.__messagetype_BizTalkDateTimeApp_Schemas_Order)
        },
        new string[]{
        }
    )]
    [Microsoft.XLANGs.BaseTypes.PortTypeAttribute(Microsoft.XLANGs.BaseTypes.EXLangSAccess.eInternal, "")]
    [System.SerializableAttribute]
    sealed internal class ReceiveOrderPortType : Microsoft.BizTalk.XLANGs.BTXEngine.BTXPortBase
    {
        public ReceiveOrderPortType(int portInfo, Microsoft.XLANGs.Core.IServiceProxy s)
            : base(portInfo, s)
        { }
        public ReceiveOrderPortType(ReceiveOrderPortType p)
            : base(p)
        { }

        public override Microsoft.XLANGs.Core.PortBase Clone()
        {
            ReceiveOrderPortType p = new ReceiveOrderPortType(this);
            return p;
        }

        public static readonly Microsoft.XLANGs.BaseTypes.EXLangSAccess __access = Microsoft.XLANGs.BaseTypes.EXLangSAccess.eInternal;
        #region port reflection support
        static public Microsoft.XLANGs.Core.OperationInfo ReceiveOrder = new Microsoft.XLANGs.Core.OperationInfo
        (
            "ReceiveOrder",
            System.Web.Services.Description.OperationFlow.OneWay,
            typeof(ReceiveOrderPortType),
            typeof(__messagetype_BizTalkDateTimeApp_Schemas_Order),
            null,
            new System.Type[]{},
            new string[]{}
        );
        static public System.Collections.Hashtable OperationsInformation
        {
            get
            {
                System.Collections.Hashtable h = new System.Collections.Hashtable();
                h[ "ReceiveOrder" ] = ReceiveOrder;
                return h;
            }
        }
        #endregion // port reflection support
    }
    //#line 172 "C:\Users\fmalgreve\SkyDrive\Documents\Blog\todo\BizTalkDateTimeApp\BizTalkDateTimeApp\BizTalkDateTimeApp\Orchestrations\ProcessOrder.odx"
    [Microsoft.XLANGs.BaseTypes.StaticSubscriptionAttribute(
        0, "ReceiveOrderPort", "ReceiveOrder", -1, -1, true
    )]
    [Microsoft.XLANGs.BaseTypes.ServicePortsAttribute(
        new Microsoft.XLANGs.BaseTypes.EXLangSParameter[] {
            Microsoft.XLANGs.BaseTypes.EXLangSParameter.ePort|Microsoft.XLANGs.BaseTypes.EXLangSParameter.eImplements
        },
        new System.Type[] {
            typeof(BizTalkDateTimeApp.ReceiveOrderPortType)
        },
        new System.String[] {
            "ReceiveOrderPort"
        },
        new System.Type[] {
            null
        }
    )]
    [Microsoft.XLANGs.BaseTypes.ServiceCallTreeAttribute(
        new System.Type[] {
        },
        new System.Type[] {
        },
        new System.Type[] {
        }
    )]
    [Microsoft.XLANGs.BaseTypes.ServiceAttribute(
        Microsoft.XLANGs.BaseTypes.EXLangSAccess.eInternal,
        Microsoft.XLANGs.BaseTypes.EXLangSServiceInfo.eNone
    )]
    [System.SerializableAttribute]
    [Microsoft.XLANGs.BaseTypes.BPELExportableAttribute(false)]
    sealed internal class ProcessOrder : Microsoft.BizTalk.XLANGs.BTXEngine.BTXService
    {
        public static readonly Microsoft.XLANGs.BaseTypes.EXLangSAccess __access = Microsoft.XLANGs.BaseTypes.EXLangSAccess.eInternal;
        public static readonly bool __execable = false;
        [Microsoft.XLANGs.BaseTypes.CallCompensationAttribute(
            Microsoft.XLANGs.BaseTypes.EXLangSCallCompensationInfo.eNone,
            new System.String[] {
            },
            new System.String[] {
            }
        )]
        public static void __bodyProxy()
        {
        }
        private static System.Guid _serviceId = Microsoft.XLANGs.Core.HashHelper.HashServiceType(typeof(ProcessOrder));
        private static volatile System.Guid[] _activationSubIds;

        private static new object _lockIdentity = new object();

        public static System.Guid UUID { get { return _serviceId; } }
        public override System.Guid ServiceId { get { return UUID; } }

        protected override System.Guid[] ActivationSubGuids
        {
            get { return _activationSubIds; }
            set { _activationSubIds = value; }
        }

        protected override object StaleStateLock
        {
            get { return _lockIdentity; }
        }

        protected override bool HasActivation { get { return true; } }

        internal bool IsExeced = false;

        static ProcessOrder()
        {
            Microsoft.BizTalk.XLANGs.BTXEngine.BTXService.CacheStaticState( _serviceId );
        }

        private void ConstructorHelper()
        {
            _segments = new Microsoft.XLANGs.Core.Segment[] {
                new Microsoft.XLANGs.Core.Segment( new Microsoft.XLANGs.Core.Segment.SegmentCode(this.segment0), 0, 0, 0),
                new Microsoft.XLANGs.Core.Segment( new Microsoft.XLANGs.Core.Segment.SegmentCode(this.segment1), 1, 1, 1)
            };

            _Locks = 0;
            _rootContext = new __ProcessOrder_root_0(this);
            _stateMgrs = new Microsoft.XLANGs.Core.IStateManager[2];
            _stateMgrs[0] = _rootContext;
            FinalConstruct();
        }

        public ProcessOrder(System.Guid instanceId, Microsoft.BizTalk.XLANGs.BTXEngine.BTXSession session, Microsoft.BizTalk.XLANGs.BTXEngine.BTXEvents tracker)
            : base(instanceId, session, "ProcessOrder", tracker)
        {
            ConstructorHelper();
        }

        public ProcessOrder(int callIndex, System.Guid instanceId, Microsoft.BizTalk.XLANGs.BTXEngine.BTXService parent)
            : base(callIndex, instanceId, parent, "ProcessOrder")
        {
            ConstructorHelper();
        }

        private const string _symInfo = @"
<XsymFile>
<ProcessFlow xmlns:om='http://schemas.microsoft.com/BizTalk/2003/DesignerData'>      <shapeType>RootShape</shapeType>      <ShapeID>870d2f30-ef1e-4f32-9fef-97bfa974b649</ShapeID>      
<children>                          
<ShapeInfo>      <shapeType>ReceiveShape</shapeType>      <ShapeID>64d85f82-44d3-4e0b-b2a9-466d8d251f2f</ShapeID>      <ParentLink>ServiceBody_Statement</ParentLink>                <shapeText>Receive Order</shapeText>                  
<children>                </children>
  </ShapeInfo>
                            
<ShapeInfo>      <shapeType>VariableAssignmentShape</shapeType>      <ShapeID>5eaae64e-3bb9-4317-8c02-cefe2e185659</ShapeID>      <ParentLink>ServiceBody_Statement</ParentLink>                <shapeText>Trace datetime elements</shapeText>                  
<children>                </children>
  </ShapeInfo>
                  </children>
  </ProcessFlow><Metadata>

<TrkMetadata>
<ActionName>'ProcessOrder'</ActionName><IsAtomic>0</IsAtomic><Line>172</Line><Position>14</Position><ShapeID>'e211a116-cb8b-44e7-a052-0de295aa0001'</ShapeID>
</TrkMetadata>

<TrkMetadata>
<Line>190</Line><Position>22</Position><ShapeID>'64d85f82-44d3-4e0b-b2a9-466d8d251f2f'</ShapeID>
<Messages>
	<MsgInfo><name>orderMsg</name><part>part</part><schema>BizTalkDateTimeApp.Schemas.Order</schema><direction>Out</direction></MsgInfo>
</Messages>
</TrkMetadata>

<TrkMetadata>
<Line>196</Line><Position>20</Position><ShapeID>'5eaae64e-3bb9-4317-8c02-cefe2e185659'</ShapeID>
<Messages>
</Messages>
</TrkMetadata>
</Metadata>
</XsymFile>";

        public override string odXml { get { return _symODXML; } }

        private const string _symODXML = @"
<?xml version='1.0' encoding='utf-8' standalone='yes'?>
<om:MetaModel MajorVersion='1' MinorVersion='3' Core='2b131234-7959-458d-834f-2dc0769ce683' ScheduleModel='66366196-361d-448d-976f-cab5e87496d2' xmlns:om='http://schemas.microsoft.com/BizTalk/2003/DesignerData'>
    <om:Element Type='Module' OID='5bfa0d65-e36f-43e5-9341-058d8b53a68d' LowerBound='1.1' HigherBound='88.1'>
        <om:Property Name='ReportToAnalyst' Value='True' />
        <om:Property Name='Name' Value='BizTalkDateTimeApp' />
        <om:Property Name='Signal' Value='False' />
        <om:Element Type='PortType' OID='8efe0721-4083-4c5a-9eb4-aa2dde149d37' ParentLink='Module_PortType' LowerBound='4.1' HigherBound='11.1'>
            <om:Property Name='Synchronous' Value='False' />
            <om:Property Name='TypeModifier' Value='Internal' />
            <om:Property Name='ReportToAnalyst' Value='True' />
            <om:Property Name='Name' Value='ReceiveOrderPortType' />
            <om:Property Name='Signal' Value='False' />
            <om:Element Type='OperationDeclaration' OID='a1c5ba1c-d18b-404c-91e8-cbfe55e2ca10' ParentLink='PortType_OperationDeclaration' LowerBound='6.1' HigherBound='10.1'>
                <om:Property Name='OperationType' Value='OneWay' />
                <om:Property Name='ReportToAnalyst' Value='True' />
                <om:Property Name='Name' Value='ReceiveOrder' />
                <om:Property Name='Signal' Value='True' />
                <om:Element Type='MessageRef' OID='699ca4cd-e1fe-473b-835c-4921e53a96d5' ParentLink='OperationDeclaration_RequestMessageRef' LowerBound='8.13' HigherBound='8.26'>
                    <om:Property Name='Ref' Value='BizTalkDateTimeApp.Schemas.Order' />
                    <om:Property Name='ReportToAnalyst' Value='True' />
                    <om:Property Name='Name' Value='Request' />
                    <om:Property Name='Signal' Value='True' />
                </om:Element>
            </om:Element>
        </om:Element>
        <om:Element Type='ServiceDeclaration' OID='7aeaf8bb-483a-4417-9304-2c1c4a9e8b05' ParentLink='Module_ServiceDeclaration' LowerBound='11.1' HigherBound='87.1'>
            <om:Property Name='InitializedTransactionType' Value='False' />
            <om:Property Name='IsInvokable' Value='False' />
            <om:Property Name='TypeModifier' Value='Internal' />
            <om:Property Name='ReportToAnalyst' Value='True' />
            <om:Property Name='Name' Value='ProcessOrder' />
            <om:Property Name='Signal' Value='False' />
            <om:Element Type='VariableDeclaration' OID='f5766c9f-de28-4a94-9fa9-f91430d9c3eb' ParentLink='ServiceDeclaration_VariableDeclaration' LowerBound='17.1' HigherBound='18.1'>
                <om:Property Name='UseDefaultConstructor' Value='False' />
                <om:Property Name='Type' Value='System.DateTime' />
                <om:Property Name='ParamDirection' Value='In' />
                <om:Property Name='ReportToAnalyst' Value='True' />
                <om:Property Name='Name' Value='orderProviderTime' />
                <om:Property Name='Signal' Value='True' />
            </om:Element>
            <om:Element Type='VariableDeclaration' OID='5c15ca46-32be-4922-8f94-5b7ef7920d8f' ParentLink='ServiceDeclaration_VariableDeclaration' LowerBound='18.1' HigherBound='19.1'>
                <om:Property Name='UseDefaultConstructor' Value='False' />
                <om:Property Name='Type' Value='System.DateTime' />
                <om:Property Name='ParamDirection' Value='In' />
                <om:Property Name='ReportToAnalyst' Value='True' />
                <om:Property Name='Name' Value='orderUtcTime' />
                <om:Property Name='Signal' Value='True' />
            </om:Element>
            <om:Element Type='VariableDeclaration' OID='90ed94d2-fcff-4679-8d35-df8955547579' ParentLink='ServiceDeclaration_VariableDeclaration' LowerBound='19.1' HigherBound='20.1'>
                <om:Property Name='UseDefaultConstructor' Value='False' />
                <om:Property Name='Type' Value='System.DateTime' />
                <om:Property Name='ParamDirection' Value='In' />
                <om:Property Name='ReportToAnalyst' Value='True' />
                <om:Property Name='Name' Value='orderBizTalkTime' />
                <om:Property Name='Signal' Value='True' />
            </om:Element>
            <om:Element Type='VariableDeclaration' OID='4a556677-6989-4587-87df-a88958125179' ParentLink='ServiceDeclaration_VariableDeclaration' LowerBound='20.1' HigherBound='21.1'>
                <om:Property Name='UseDefaultConstructor' Value='False' />
                <om:Property Name='Type' Value='System.String' />
                <om:Property Name='ParamDirection' Value='In' />
                <om:Property Name='ReportToAnalyst' Value='True' />
                <om:Property Name='Name' Value='strOrderProviderTime' />
                <om:Property Name='Signal' Value='True' />
            </om:Element>
            <om:Element Type='VariableDeclaration' OID='be80b889-2070-4be8-a1c0-c9ee73ddfaec' ParentLink='ServiceDeclaration_VariableDeclaration' LowerBound='21.1' HigherBound='22.1'>
                <om:Property Name='UseDefaultConstructor' Value='False' />
                <om:Property Name='Type' Value='System.String' />
                <om:Property Name='ParamDirection' Value='In' />
                <om:Property Name='ReportToAnalyst' Value='True' />
                <om:Property Name='Name' Value='strOrderUtcTime' />
                <om:Property Name='Signal' Value='True' />
            </om:Element>
            <om:Element Type='VariableDeclaration' OID='57d89742-ba26-408c-99c4-d8ccf43cbe4c' ParentLink='ServiceDeclaration_VariableDeclaration' LowerBound='22.1' HigherBound='23.1'>
                <om:Property Name='UseDefaultConstructor' Value='False' />
                <om:Property Name='Type' Value='System.String' />
                <om:Property Name='ParamDirection' Value='In' />
                <om:Property Name='ReportToAnalyst' Value='True' />
                <om:Property Name='Name' Value='strOrderBiztalkTime' />
                <om:Property Name='Signal' Value='True' />
            </om:Element>
            <om:Element Type='VariableDeclaration' OID='6ca14bb8-1cce-48c9-8ebd-1c3fd639a0be' ParentLink='ServiceDeclaration_VariableDeclaration' LowerBound='23.1' HigherBound='24.1'>
                <om:Property Name='UseDefaultConstructor' Value='True' />
                <om:Property Name='Type' Value='System.Xml.XmlDocument' />
                <om:Property Name='ParamDirection' Value='In' />
                <om:Property Name='ReportToAnalyst' Value='True' />
                <om:Property Name='Name' Value='xmlDoc' />
                <om:Property Name='Signal' Value='True' />
            </om:Element>
            <om:Element Type='VariableDeclaration' OID='1d19a7b0-d333-490c-a0e4-862e419bdb48' ParentLink='ServiceDeclaration_VariableDeclaration' LowerBound='24.1' HigherBound='25.1'>
                <om:Property Name='UseDefaultConstructor' Value='False' />
                <om:Property Name='Type' Value='System.DateTime' />
                <om:Property Name='ParamDirection' Value='In' />
                <om:Property Name='ReportToAnalyst' Value='True' />
                <om:Property Name='Name' Value='parsedOrderProviderTime' />
                <om:Property Name='Signal' Value='True' />
            </om:Element>
            <om:Element Type='VariableDeclaration' OID='f199b839-001d-43f5-a104-88d1d2de1df3' ParentLink='ServiceDeclaration_VariableDeclaration' LowerBound='25.1' HigherBound='26.1'>
                <om:Property Name='UseDefaultConstructor' Value='False' />
                <om:Property Name='Type' Value='System.DateTimeOffset' />
                <om:Property Name='ParamDirection' Value='In' />
                <om:Property Name='ReportToAnalyst' Value='True' />
                <om:Property Name='Name' Value='orderProviderDateTimeOffset' />
                <om:Property Name='Signal' Value='True' />
            </om:Element>
            <om:Element Type='VariableDeclaration' OID='8c4fd08b-11b0-4fa7-92c4-0fee3ccace63' ParentLink='ServiceDeclaration_VariableDeclaration' LowerBound='26.1' HigherBound='27.1'>
                <om:Property Name='UseDefaultConstructor' Value='False' />
                <om:Property Name='Type' Value='System.DateTime' />
                <om:Property Name='ParamDirection' Value='In' />
                <om:Property Name='ReportToAnalyst' Value='True' />
                <om:Property Name='Name' Value='orderProviderTimePromoted' />
                <om:Property Name='Signal' Value='True' />
            </om:Element>
            <om:Element Type='MessageDeclaration' OID='32479331-d76a-4399-928a-0eb5157230be' ParentLink='ServiceDeclaration_MessageDeclaration' LowerBound='16.1' HigherBound='17.1'>
                <om:Property Name='Type' Value='BizTalkDateTimeApp.Schemas.Order' />
                <om:Property Name='ParamDirection' Value='In' />
                <om:Property Name='ReportToAnalyst' Value='True' />
                <om:Property Name='Name' Value='orderMsg' />
                <om:Property Name='Signal' Value='True' />
            </om:Element>
            <om:Element Type='ServiceBody' OID='870d2f30-ef1e-4f32-9fef-97bfa974b649' ParentLink='ServiceDeclaration_ServiceBody'>
                <om:Property Name='Signal' Value='False' />
                <om:Element Type='Receive' OID='64d85f82-44d3-4e0b-b2a9-466d8d251f2f' ParentLink='ServiceBody_Statement' LowerBound='29.1' HigherBound='35.1'>
                    <om:Property Name='Activate' Value='True' />
                    <om:Property Name='PortName' Value='ReceiveOrderPort' />
                    <om:Property Name='MessageName' Value='orderMsg' />
                    <om:Property Name='OperationName' Value='ReceiveOrder' />
                    <om:Property Name='OperationMessageName' Value='Request' />
                    <om:Property Name='ReportToAnalyst' Value='True' />
                    <om:Property Name='Name' Value='Receive Order' />
                    <om:Property Name='Signal' Value='True' />
                </om:Element>
                <om:Element Type='VariableAssignment' OID='5eaae64e-3bb9-4317-8c02-cefe2e185659' ParentLink='ServiceBody_Statement' LowerBound='35.1' HigherBound='85.1'>
                    <om:Property Name='Expression' Value='xmlDoc = orderMsg;&#xD;&#xA;System.Diagnostics.Trace.WriteLine(&quot;****** BizTalkDateTimeApp: orderMsg raw:&quot;);&#xD;&#xA;System.Diagnostics.Trace.WriteLine(xmlDoc.OuterXml);&#xD;&#xA;&#xD;&#xA;orderProviderTime = orderMsg.ProviderTime;&#xD;&#xA;orderUtcTime = orderMsg.UTCTime;&#xD;&#xA;orderBizTalkTime = orderMsg.BizTalkServerTime;&#xD;&#xA;System.Diagnostics.Trace.WriteLine(&quot;****** BizTalkDateTimeApp: datetime distinguished field orderProviderTime.Kind | orderProviderTime.ToString() = &quot; + System.Convert.ToString(orderProviderTime.Kind) + &quot; | &quot; + orderProviderTime.ToString());&#xD;&#xA;System.Diagnostics.Trace.WriteLine(&quot;****** BizTalkDateTimeApp: datetime distinguished field orderUtcTime.Kind | orderUtcTime.ToString() = &quot; + System.Convert.ToString(orderUtcTime.Kind) + &quot; | &quot; + orderUtcTime.ToString());&#xD;&#xA;System.Diagnostics.Trace.WriteLine(&quot;****** BizTalkDateTimeApp: datetime distinguished field orderBizTalkTime.Kind | orderBizTalkTime.ToString() = &quot; + System.Convert.ToString(orderBizTalkTime.Kind) + &quot; | &quot; + orderBizTalkTime.ToString());&#xD;&#xA;&#xD;&#xA;orderProviderTime = orderProviderTime.ToLocalTime();&#xD;&#xA;orderUtcTime = orderUtcTime.ToLocalTime();&#xD;&#xA;orderBizTalkTime = orderBizTalkTime.ToLocalTime();&#xD;&#xA;System.Diagnostics.Trace.WriteLine(&quot;****** BizTalkDateTimeApp: datetime distinguished field localized orderProviderTime.Kind | orderProviderTime.ToString() = &quot; + System.Convert.ToString(orderProviderTime.Kind) + &quot; | &quot; + orderProviderTime.ToString());&#xD;&#xA;System.Diagnostics.Trace.WriteLine(&quot;****** BizTalkDateTimeApp: datetime distinguished field localized orderUtcTime.Kind | orderUtcTime.ToString() = &quot; + System.Convert.ToString(orderUtcTime.Kind) + &quot; | &quot; + orderUtcTime.ToString());&#xD;&#xA;System.Diagnostics.Trace.WriteLine(&quot;****** BizTalkDateTimeApp: datetime distinguished field localized orderBizTalkTi"+
@"me.Kind | orderBizTalkTime.ToString() = &quot; + System.Convert.ToString(orderBizTalkTime.Kind) + &quot; | &quot; + orderBizTalkTime.ToString());&#xD;&#xA;&#xD;&#xA;strOrderProviderTime = xpath(orderMsg, &quot;string(/*[local-name()=&apos;Order&apos; and namespace-uri()=&apos;http://BizTalkDateTimeApp.Order&apos;]/*[local-name()=&apos;ProviderTime&apos; and namespace-uri()=&apos;http://BizTalkDateTimeApp.Order&apos;]/text())&quot;);&#xD;&#xA;strOrderUtcTime = xpath(orderMsg, &quot;string(/*[local-name()=&apos;Order&apos; and namespace-uri()=&apos;http://BizTalkDateTimeApp.Order&apos;]/*[local-name()=&apos;UTCTime&apos; and namespace-uri()=&apos;http://BizTalkDateTimeApp.Order&apos;]/text())&quot;);&#xD;&#xA;strOrderBiztalkTime = xpath(orderMsg, &quot;string(/*[local-name()=&apos;Order&apos; and namespace-uri()=&apos;http://BizTalkDateTimeApp.Order&apos;]/*[local-name()=&apos;BizTalkServerTime&apos; and namespace-uri()=&apos;http://BizTalkDateTimeApp.Order&apos;]/text())&quot;);&#xD;&#xA;System.Diagnostics.Trace.WriteLine(&quot;****** BizTalkDateTimeApp: xpath string value from element ProviderTime = &quot; + strOrderProviderTime);&#xD;&#xA;System.Diagnostics.Trace.WriteLine(&quot;****** BizTalkDateTimeApp: xpath string value from element UTCTime = &quot; + strOrderUtcTime);&#xD;&#xA;System.Diagnostics.Trace.WriteLine(&quot;****** BizTalkDateTimeApp: xpath string value from element BizTalkServerTime = &quot; + strOrderBiztalkTime);&#xD;&#xA;&#xD;&#xA;parsedOrderProviderTime = System.Xml.XmlConvert.ToDateTime(strOrderProviderTime, System.Xml.XmlDateTimeSerializationMode.RoundtripKind);&#xD;&#xA;System.Diagnostics.Trace.WriteLine(&quot;****** BizTalkDateTimeApp: parsed datetime (roundtrip) parsedOrderProviderTime.Kind | parsedOrderProviderTime.ToString() = &quot; + System.Convert.ToString(parsedOrderProviderTime.Kind) + &quot; | &quot; + parsedOrderProviderTime.ToString());&#xD;&#xA;&#xD;&#xA;parsedOrderProviderTime = System.Xml.XmlConvert.ToDateTime(strOrderProviderTime, System.Xml.XmlDateTimeSerializati"+
@"onMode.Unspecified);&#xD;&#xA;System.Diagnostics.Trace.WriteLine(&quot;****** BizTalkDateTimeApp: parsed datetime (unspecified) parsedOrderProviderTime.Kind | parsedOrderProviderTime.ToString() = &quot; + System.Convert.ToString(parsedOrderProviderTime.Kind) + &quot; | &quot; + parsedOrderProviderTime.ToString());&#xD;&#xA;&#xD;&#xA;parsedOrderProviderTime = System.Xml.XmlConvert.ToDateTime(strOrderProviderTime, System.Xml.XmlDateTimeSerializationMode.Local);&#xD;&#xA;System.Diagnostics.Trace.WriteLine(&quot;****** BizTalkDateTimeApp: parsed datetime (local) parsedOrderProviderTime.Kind | parsedOrderProviderTime.ToString() = &quot; + System.Convert.ToString(parsedOrderProviderTime.Kind) + &quot; | &quot; + parsedOrderProviderTime.ToString());&#xD;&#xA;&#xD;&#xA;parsedOrderProviderTime = System.Xml.XmlConvert.ToDateTime(strOrderProviderTime, System.Xml.XmlDateTimeSerializationMode.Utc);&#xD;&#xA;System.Diagnostics.Trace.WriteLine(&quot;****** BizTalkDateTimeApp: parsed datetime (utc) parsedOrderProviderTime.Kind | parsedOrderProviderTime.ToString() = &quot; + System.Convert.ToString(parsedOrderProviderTime.Kind) + &quot; | &quot; + parsedOrderProviderTime.ToString());&#xD;&#xA;&#xD;&#xA;parsedOrderProviderTime = System.Xml.XmlConvert.ToDateTime(strOrderProviderTime);&#xD;&#xA;System.Diagnostics.Trace.WriteLine(&quot;****** BizTalkDateTimeApp: parsed datetime (obsolete overload - but still used by many!) parsedOrderProviderTime.Kind | parsedOrderProviderTime.ToString() = &quot; + System.Convert.ToString(parsedOrderProviderTime.Kind) + &quot; | &quot; + parsedOrderProviderTime.ToString());&#xD;&#xA;&#xD;&#xA;orderProviderDateTimeOffset = new System.DateTimeOffset(orderMsg.ProviderTime);&#xD;&#xA;System.Diagnostics.Trace.WriteLine(&quot;****** BizTalkDateTimeApp: datetimeoffset distinguished field orderProviderDateTimeOffset.Offset | orderProviderDateTimeOffset.ToString() = &quot; + orderProviderDateTimeOffset.Offset.ToString() + &quot; | &quot; + orderProviderDateTimeOffset.ToString());&#xD;&#xA;&#xD;&#xA"+
@";orderProviderDateTimeOffset = System.Xml.XmlConvert.ToDateTimeOffset(strOrderProviderTime);&#xD;&#xA;System.Diagnostics.Trace.WriteLine(&quot;****** BizTalkDateTimeApp: datetimeoffset parsed from Xpath orderProviderDateTimeOffset.Offset | orderProviderDateTimeOffset.ToString(\&quot;f\&quot;) = &quot; + orderProviderDateTimeOffset.Offset.ToString() + &quot; | &quot; + orderProviderDateTimeOffset.ToString(&quot;f&quot;));&#xD;&#xA;&#xD;&#xA;&#xD;&#xA;orderProviderTimePromoted = orderMsg(BizTalkDateTimeApp.Schemas.OrderDate);&#xD;&#xA;System.Diagnostics.Trace.WriteLine(&quot;****** BizTalkDateTimeApp: datetime promoted property orderProviderTimePromoted.Kind | orderProviderTimePromoted.ToString() = &quot; + System.Convert.ToString(orderProviderTimePromoted.Kind) + &quot; | &quot; + orderProviderTimePromoted.ToString());' />
                    <om:Property Name='ReportToAnalyst' Value='True' />
                    <om:Property Name='Name' Value='Trace datetime elements' />
                    <om:Property Name='Signal' Value='True' />
                </om:Element>
            </om:Element>
            <om:Element Type='PortDeclaration' OID='d0e8ad96-c07b-49dd-8985-1da5e8e72ffb' ParentLink='ServiceDeclaration_PortDeclaration' LowerBound='14.1' HigherBound='16.1'>
                <om:Property Name='PortModifier' Value='Implements' />
                <om:Property Name='Orientation' Value='Left' />
                <om:Property Name='PortIndex' Value='-1' />
                <om:Property Name='IsWebPort' Value='False' />
                <om:Property Name='OrderedDelivery' Value='False' />
                <om:Property Name='DeliveryNotification' Value='None' />
                <om:Property Name='Type' Value='BizTalkDateTimeApp.ReceiveOrderPortType' />
                <om:Property Name='ParamDirection' Value='In' />
                <om:Property Name='ReportToAnalyst' Value='True' />
                <om:Property Name='Name' Value='ReceiveOrderPort' />
                <om:Property Name='Signal' Value='False' />
                <om:Element Type='LogicalBindingAttribute' OID='ad2ecc27-8aff-4ab5-ad75-12256e1b977c' ParentLink='PortDeclaration_CLRAttribute' LowerBound='14.1' HigherBound='15.1'>
                    <om:Property Name='Signal' Value='False' />
                </om:Element>
            </om:Element>
        </om:Element>
    </om:Element>
</om:MetaModel>
";

        [System.SerializableAttribute]
        public class __ProcessOrder_root_0 : Microsoft.XLANGs.Core.ServiceContext
        {
            public __ProcessOrder_root_0(Microsoft.XLANGs.Core.Service svc)
                : base(svc, "ProcessOrder")
            {
            }

            public override int Index { get { return 0; } }

            public override Microsoft.XLANGs.Core.Segment InitialSegment
            {
                get { return _service._segments[0]; }
            }
            public override Microsoft.XLANGs.Core.Segment FinalSegment
            {
                get { return _service._segments[0]; }
            }

            public override int CompensationSegment { get { return -1; } }
            public override bool OnError()
            {
                Finally();
                return false;
            }

            public override void Finally()
            {
                ProcessOrder __svc__ = (ProcessOrder)_service;
                __ProcessOrder_root_0 __ctx0__ = (__ProcessOrder_root_0)(__svc__._stateMgrs[0]);

                if (__svc__.ReceiveOrderPort != null)
                {
                    __svc__.ReceiveOrderPort.Close(this, null);
                    __svc__.ReceiveOrderPort = null;
                }
                base.Finally();
            }

            internal Microsoft.XLANGs.Core.SubscriptionWrapper __subWrapper0;
        }


        [System.SerializableAttribute]
        public class __ProcessOrder_1 : Microsoft.XLANGs.Core.ExceptionHandlingContext
        {
            public __ProcessOrder_1(Microsoft.XLANGs.Core.Service svc)
                : base(svc, "ProcessOrder")
            {
            }

            public override int Index { get { return 1; } }

            public override bool CombineParentCommit { get { return true; } }

            public override Microsoft.XLANGs.Core.Segment InitialSegment
            {
                get { return _service._segments[1]; }
            }
            public override Microsoft.XLANGs.Core.Segment FinalSegment
            {
                get { return _service._segments[1]; }
            }

            public override int CompensationSegment { get { return -1; } }
            public override bool OnError()
            {
                Finally();
                return false;
            }

            public override void Finally()
            {
                ProcessOrder __svc__ = (ProcessOrder)_service;
                __ProcessOrder_1 __ctx1__ = (__ProcessOrder_1)(__svc__._stateMgrs[1]);

                if (__ctx1__ != null)
                    __ctx1__.__strOrderProviderTime = null;
                if (__ctx1__ != null)
                    __ctx1__.__strOrderUtcTime = null;
                if (__ctx1__ != null)
                    __ctx1__.__strOrderBiztalkTime = null;
                if (__ctx1__ != null)
                    __ctx1__.__xmlDoc = null;
                if (__ctx1__ != null && __ctx1__.__orderMsg != null)
                {
                    __ctx1__.UnrefMessage(__ctx1__.__orderMsg);
                    __ctx1__.__orderMsg = null;
                }
                base.Finally();
            }

            [Microsoft.XLANGs.Core.UserVariableAttribute("orderMsg")]
            public __messagetype_BizTalkDateTimeApp_Schemas_Order __orderMsg;
            [Microsoft.XLANGs.Core.UserVariableAttribute("orderProviderTime")]
            internal System.DateTime __orderProviderTime;
            [Microsoft.XLANGs.Core.UserVariableAttribute("orderUtcTime")]
            internal System.DateTime __orderUtcTime;
            [Microsoft.XLANGs.Core.UserVariableAttribute("orderBizTalkTime")]
            internal System.DateTime __orderBizTalkTime;
            [Microsoft.XLANGs.Core.UserVariableAttribute("strOrderProviderTime")]
            internal System.String __strOrderProviderTime;
            [Microsoft.XLANGs.Core.UserVariableAttribute("strOrderUtcTime")]
            internal System.String __strOrderUtcTime;
            [Microsoft.XLANGs.Core.UserVariableAttribute("strOrderBiztalkTime")]
            internal System.String __strOrderBiztalkTime;
            [Microsoft.XLANGs.Core.UserVariableAttribute("xmlDoc")]
            internal Microsoft.XLANGs.RuntimeTypes.XmlDocumentSerializationProxy __xmlDoc;
            [Microsoft.XLANGs.Core.UserVariableAttribute("parsedOrderProviderTime")]
            internal System.DateTime __parsedOrderProviderTime;
            [Microsoft.XLANGs.Core.UserVariableAttribute("orderProviderDateTimeOffset")]
            internal System.DateTimeOffset __orderProviderDateTimeOffset;
            [Microsoft.XLANGs.Core.UserVariableAttribute("orderProviderTimePromoted")]
            internal System.DateTime __orderProviderTimePromoted;
        }

        private static Microsoft.XLANGs.Core.CorrelationType[] _correlationTypes = null;
        public override Microsoft.XLANGs.Core.CorrelationType[] CorrelationTypes { get { return _correlationTypes; } }

        private static System.Guid[] _convoySetIds;

        public override System.Guid[] ConvoySetGuids
        {
            get { return _convoySetIds; }
            set { _convoySetIds = value; }
        }

        public static object[] StaticConvoySetInformation
        {
            get {
                return null;
            }
        }

        [Microsoft.XLANGs.BaseTypes.LogicalBindingAttribute()]
        [Microsoft.XLANGs.BaseTypes.PortAttribute(
            Microsoft.XLANGs.BaseTypes.EXLangSParameter.eImplements
        )]
        [Microsoft.XLANGs.Core.UserVariableAttribute("ReceiveOrderPort")]
        internal ReceiveOrderPortType ReceiveOrderPort;

        public static Microsoft.XLANGs.Core.PortInfo[] _portInfo = new Microsoft.XLANGs.Core.PortInfo[] {
            new Microsoft.XLANGs.Core.PortInfo(new Microsoft.XLANGs.Core.OperationInfo[] {ReceiveOrderPortType.ReceiveOrder},
                                               typeof(ProcessOrder).GetField("ReceiveOrderPort", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance),
                                               Microsoft.XLANGs.BaseTypes.Polarity.implements,
                                               false,
                                               Microsoft.XLANGs.Core.HashHelper.HashPort(typeof(ProcessOrder), "ReceiveOrderPort"),
                                               null)
        };

        public override Microsoft.XLANGs.Core.PortInfo[] PortInformation
        {
            get { return _portInfo; }
        }

        static public System.Collections.Hashtable PortsInformation
        {
            get
            {
                System.Collections.Hashtable h = new System.Collections.Hashtable();
                h[_portInfo[0].Name] = _portInfo[0];
                return h;
            }
        }

        public static System.Type[] InvokedServicesTypes
        {
            get
            {
                return new System.Type[] {
                    // type of each service invoked by this service
                };
            }
        }

        public static System.Type[] CalledServicesTypes
        {
            get
            {
                return new System.Type[] {
                };
            }
        }

        public static System.Type[] ExecedServicesTypes
        {
            get
            {
                return new System.Type[] {
                };
            }
        }

        public static object[] StaticSubscriptionsInformation {
            get {
                return new object[1]{
                     new object[5] { _portInfo[0], 0, null , -1, true }
                };
            }
        }

        public static Microsoft.XLANGs.RuntimeTypes.Location[] __eventLocations = new Microsoft.XLANGs.RuntimeTypes.Location[] {
            new Microsoft.XLANGs.RuntimeTypes.Location(0, "00000000-0000-0000-0000-000000000000", 1, true),
            new Microsoft.XLANGs.RuntimeTypes.Location(1, "64d85f82-44d3-4e0b-b2a9-466d8d251f2f", 1, true),
            new Microsoft.XLANGs.RuntimeTypes.Location(2, "64d85f82-44d3-4e0b-b2a9-466d8d251f2f", 1, false),
            new Microsoft.XLANGs.RuntimeTypes.Location(3, "00000000-0000-0000-0000-000000000000", 1, false),
            new Microsoft.XLANGs.RuntimeTypes.Location(4, "5eaae64e-3bb9-4317-8c02-cefe2e185659", 1, true),
            new Microsoft.XLANGs.RuntimeTypes.Location(5, "5eaae64e-3bb9-4317-8c02-cefe2e185659", 1, false)
        };

        public override Microsoft.XLANGs.RuntimeTypes.Location[] EventLocations
        {
            get { return __eventLocations; }
        }

        public static Microsoft.XLANGs.RuntimeTypes.EventData[] __eventData = new Microsoft.XLANGs.RuntimeTypes.EventData[] {
            new Microsoft.XLANGs.RuntimeTypes.EventData( Microsoft.XLANGs.RuntimeTypes.Operation.Start | Microsoft.XLANGs.RuntimeTypes.Operation.Body),
            new Microsoft.XLANGs.RuntimeTypes.EventData( Microsoft.XLANGs.RuntimeTypes.Operation.Start | Microsoft.XLANGs.RuntimeTypes.Operation.Receive),
            new Microsoft.XLANGs.RuntimeTypes.EventData( Microsoft.XLANGs.RuntimeTypes.Operation.Start | Microsoft.XLANGs.RuntimeTypes.Operation.Expression),
            new Microsoft.XLANGs.RuntimeTypes.EventData( Microsoft.XLANGs.RuntimeTypes.Operation.End | Microsoft.XLANGs.RuntimeTypes.Operation.Expression),
            new Microsoft.XLANGs.RuntimeTypes.EventData( Microsoft.XLANGs.RuntimeTypes.Operation.End | Microsoft.XLANGs.RuntimeTypes.Operation.Body)
        };

        public static int[] __progressLocation0 = new int[] { 0,0,0,3,3,};
        public static int[] __progressLocation1 = new int[] { 0,0,1,1,2,2,2,2,2,4,4,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,3,3,3,3,};

        public static int[][] __progressLocations = new int[2] [] {__progressLocation0,__progressLocation1};
        public override int[][] ProgressLocations {get {return __progressLocations;} }

        public Microsoft.XLANGs.Core.StopConditions segment0(Microsoft.XLANGs.Core.StopConditions stopOn)
        {
            Microsoft.XLANGs.Core.Segment __seg__ = _segments[0];
            Microsoft.XLANGs.Core.Context __ctx__ = (Microsoft.XLANGs.Core.Context)_stateMgrs[0];
            __ProcessOrder_root_0 __ctx0__ = (__ProcessOrder_root_0)_stateMgrs[0];
            __ProcessOrder_1 __ctx1__ = (__ProcessOrder_1)_stateMgrs[1];

            switch (__seg__.Progress)
            {
            case 0:
                ReceiveOrderPort = new ReceiveOrderPortType(0, this);
                __ctx__.PrologueCompleted = true;
                __ctx0__.__subWrapper0 = new Microsoft.XLANGs.Core.SubscriptionWrapper(ActivationSubGuids[0], ReceiveOrderPort, this);
                if ( !PostProgressInc( __seg__, __ctx__, 1 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                if ((stopOn & Microsoft.XLANGs.Core.StopConditions.Initialized) != 0)
                    return Microsoft.XLANGs.Core.StopConditions.Initialized;
                goto case 1;
            case 1:
                __ctx1__ = new __ProcessOrder_1(this);
                _stateMgrs[1] = __ctx1__;
                if ( !PostProgressInc( __seg__, __ctx__, 2 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 2;
            case 2:
                __ctx0__.StartContext(__seg__, __ctx1__);
                if ( !PostProgressInc( __seg__, __ctx__, 3 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                return Microsoft.XLANGs.Core.StopConditions.Blocked;
            case 3:
                if (!__ctx0__.CleanupAndPrepareToCommit(__seg__))
                    return Microsoft.XLANGs.Core.StopConditions.Blocked;
                if ( !PostProgressInc( __seg__, __ctx__, 4 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 4;
            case 4:
                __ctx1__.Finally();
                ServiceDone(__seg__, (Microsoft.XLANGs.Core.Context)_stateMgrs[0]);
                __ctx0__.OnCommit();
                break;
            }
            return Microsoft.XLANGs.Core.StopConditions.Completed;
        }

        public Microsoft.XLANGs.Core.StopConditions segment1(Microsoft.XLANGs.Core.StopConditions stopOn)
        {
            Microsoft.XLANGs.Core.Envelope __msgEnv__ = null;
            Microsoft.XLANGs.Core.Segment __seg__ = _segments[1];
            Microsoft.XLANGs.Core.Context __ctx__ = (Microsoft.XLANGs.Core.Context)_stateMgrs[1];
            __ProcessOrder_root_0 __ctx0__ = (__ProcessOrder_root_0)_stateMgrs[0];
            __ProcessOrder_1 __ctx1__ = (__ProcessOrder_1)_stateMgrs[1];

            switch (__seg__.Progress)
            {
            case 0:
                __ctx1__.__orderProviderTime = default(System.DateTime);
                __ctx1__.__orderUtcTime = default(System.DateTime);
                __ctx1__.__orderBizTalkTime = default(System.DateTime);
                __ctx1__.__strOrderProviderTime = default(System.String);
                __ctx1__.__strOrderUtcTime = default(System.String);
                __ctx1__.__strOrderBiztalkTime = default(System.String);
                __ctx1__.__xmlDoc = new Microsoft.XLANGs.RuntimeTypes.XmlDocumentSerializationProxy();
                __ctx1__.__parsedOrderProviderTime = default(System.DateTime);
                __ctx1__.__orderProviderDateTimeOffset = default(System.DateTimeOffset);
                __ctx1__.__orderProviderTimePromoted = default(System.DateTime);
                __ctx__.PrologueCompleted = true;
                if ( !PostProgressInc( __seg__, __ctx__, 1 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 1;
            case 1:
                if ( !PreProgressInc( __seg__, __ctx__, 2 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                Tracker.FireEvent(__eventLocations[0],__eventData[0],_stateMgrs[1].TrackDataStream );
                if (IsDebugged)
                    return Microsoft.XLANGs.Core.StopConditions.InBreakpoint;
                goto case 2;
            case 2:
                if ( !PreProgressInc( __seg__, __ctx__, 3 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                Tracker.FireEvent(__eventLocations[1],__eventData[1],_stateMgrs[1].TrackDataStream );
                if (IsDebugged)
                    return Microsoft.XLANGs.Core.StopConditions.InBreakpoint;
                goto case 3;
            case 3:
                if (!ReceiveOrderPort.GetMessageId(__ctx0__.__subWrapper0.getSubscription(this), __seg__, __ctx1__, out __msgEnv__))
                    return Microsoft.XLANGs.Core.StopConditions.Blocked;
                if (__ctx1__.__orderMsg != null)
                    __ctx1__.UnrefMessage(__ctx1__.__orderMsg);
                __ctx1__.__orderMsg = new __messagetype_BizTalkDateTimeApp_Schemas_Order("orderMsg", __ctx1__);
                __ctx1__.RefMessage(__ctx1__.__orderMsg);
                ReceiveOrderPort.ReceiveMessage(0, __msgEnv__, __ctx1__.__orderMsg, null, (Microsoft.XLANGs.Core.Context)_stateMgrs[1], __seg__);
                if (ReceiveOrderPort != null)
                {
                    ReceiveOrderPort.Close(__ctx1__, __seg__);
                    ReceiveOrderPort = null;
                }
                if ( !PostProgressInc( __seg__, __ctx__, 4 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 4;
            case 4:
                if ( !PreProgressInc( __seg__, __ctx__, 5 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                {
                    Microsoft.XLANGs.RuntimeTypes.EventData __edata = new Microsoft.XLANGs.RuntimeTypes.EventData(Microsoft.XLANGs.RuntimeTypes.Operation.End | Microsoft.XLANGs.RuntimeTypes.Operation.Receive);
                    __edata.Messages.Add(__ctx1__.__orderMsg);
                    __edata.PortName = @"ReceiveOrderPort";
                    Tracker.FireEvent(__eventLocations[2],__edata,_stateMgrs[1].TrackDataStream );
                }
                if (IsDebugged)
                    return Microsoft.XLANGs.Core.StopConditions.InBreakpoint;
                goto case 5;
            case 5:
                __ctx1__.__strOrderProviderTime = "";
                if ( !PostProgressInc( __seg__, __ctx__, 6 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 6;
            case 6:
                __ctx1__.__strOrderUtcTime = "";
                if ( !PostProgressInc( __seg__, __ctx__, 7 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 7;
            case 7:
                __ctx1__.__strOrderBiztalkTime = "";
                if ( !PostProgressInc( __seg__, __ctx__, 8 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 8;
            case 8:
                __ctx1__.__xmlDoc.UnderlyingXmlDocument = new System.Xml.XmlDocument();
                if ( !PostProgressInc( __seg__, __ctx__, 9 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 9;
            case 9:
                if ( !PreProgressInc( __seg__, __ctx__, 10 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                Tracker.FireEvent(__eventLocations[4],__eventData[2],_stateMgrs[1].TrackDataStream );
                if (IsDebugged)
                    return Microsoft.XLANGs.Core.StopConditions.InBreakpoint;
                goto case 10;
            case 10:
                __ctx1__.__xmlDoc.UnderlyingXmlDocument = __ctx1__.__orderMsg.part.TypedValue;
                if ( !PostProgressInc( __seg__, __ctx__, 11 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 11;
            case 11:
                if ( !PreProgressInc( __seg__, __ctx__, 12 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                Tracker.FireEvent(__eventLocations[5],__eventData[3],_stateMgrs[1].TrackDataStream );
                if (IsDebugged)
                    return Microsoft.XLANGs.Core.StopConditions.InBreakpoint;
                goto case 12;
            case 12:
                System.Diagnostics.Trace.WriteLine("****** BizTalkDateTimeApp: orderMsg raw:");
                if ( !PostProgressInc( __seg__, __ctx__, 13 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 13;
            case 13:
                System.Diagnostics.Trace.WriteLine(__ctx1__.__xmlDoc.UnderlyingXmlDocument.OuterXml);
                if (__ctx1__ != null)
                    __ctx1__.__xmlDoc = null;
                if ( !PostProgressInc( __seg__, __ctx__, 14 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 14;
            case 14:
                __ctx1__.__orderProviderTime = (System.DateTime)__ctx1__.__orderMsg.part.GetDistinguishedField("ProviderTime");
                if ( !PostProgressInc( __seg__, __ctx__, 15 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 15;
            case 15:
                __ctx1__.__orderUtcTime = (System.DateTime)__ctx1__.__orderMsg.part.GetDistinguishedField("UTCTime");
                if ( !PostProgressInc( __seg__, __ctx__, 16 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 16;
            case 16:
                __ctx1__.__orderBizTalkTime = (System.DateTime)__ctx1__.__orderMsg.part.GetDistinguishedField("BizTalkServerTime");
                if ( !PostProgressInc( __seg__, __ctx__, 17 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 17;
            case 17:
                System.Diagnostics.Trace.WriteLine("****** BizTalkDateTimeApp: datetime distinguished field orderProviderTime.Kind | orderProviderTime.ToString() = " + System.Convert.ToString(__ctx1__.__orderProviderTime.Kind) + " | " + __ctx1__.__orderProviderTime.ToString());
                if ( !PostProgressInc( __seg__, __ctx__, 18 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 18;
            case 18:
                System.Diagnostics.Trace.WriteLine("****** BizTalkDateTimeApp: datetime distinguished field orderUtcTime.Kind | orderUtcTime.ToString() = " + System.Convert.ToString(__ctx1__.__orderUtcTime.Kind) + " | " + __ctx1__.__orderUtcTime.ToString());
                if ( !PostProgressInc( __seg__, __ctx__, 19 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 19;
            case 19:
                System.Diagnostics.Trace.WriteLine("****** BizTalkDateTimeApp: datetime distinguished field orderBizTalkTime.Kind | orderBizTalkTime.ToString() = " + System.Convert.ToString(__ctx1__.__orderBizTalkTime.Kind) + " | " + __ctx1__.__orderBizTalkTime.ToString());
                if ( !PostProgressInc( __seg__, __ctx__, 20 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 20;
            case 20:
                __ctx1__.__orderProviderTime = __ctx1__.__orderProviderTime.ToLocalTime();
                if ( !PostProgressInc( __seg__, __ctx__, 21 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 21;
            case 21:
                __ctx1__.__orderUtcTime = __ctx1__.__orderUtcTime.ToLocalTime();
                if ( !PostProgressInc( __seg__, __ctx__, 22 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 22;
            case 22:
                __ctx1__.__orderBizTalkTime = __ctx1__.__orderBizTalkTime.ToLocalTime();
                if ( !PostProgressInc( __seg__, __ctx__, 23 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 23;
            case 23:
                System.Diagnostics.Trace.WriteLine("****** BizTalkDateTimeApp: datetime distinguished field localized orderProviderTime.Kind | orderProviderTime.ToString() = " + System.Convert.ToString(__ctx1__.__orderProviderTime.Kind) + " | " + __ctx1__.__orderProviderTime.ToString());
                if ( !PostProgressInc( __seg__, __ctx__, 24 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 24;
            case 24:
                System.Diagnostics.Trace.WriteLine("****** BizTalkDateTimeApp: datetime distinguished field localized orderUtcTime.Kind | orderUtcTime.ToString() = " + System.Convert.ToString(__ctx1__.__orderUtcTime.Kind) + " | " + __ctx1__.__orderUtcTime.ToString());
                if ( !PostProgressInc( __seg__, __ctx__, 25 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 25;
            case 25:
                System.Diagnostics.Trace.WriteLine("****** BizTalkDateTimeApp: datetime distinguished field localized orderBizTalkTime.Kind | orderBizTalkTime.ToString() = " + System.Convert.ToString(__ctx1__.__orderBizTalkTime.Kind) + " | " + __ctx1__.__orderBizTalkTime.ToString());
                if ( !PostProgressInc( __seg__, __ctx__, 26 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 26;
            case 26:
                __ctx1__.__strOrderProviderTime = (System.String)Microsoft.XLANGs.Core.Part.XPathLoad(__ctx1__.__orderMsg.part, "string(/*[local-name()='Order' and namespace-uri()='http://BizTalkDateTimeApp.Order']/*[local-name()='ProviderTime' and namespace-uri()='http://BizTalkDateTimeApp.Order']/text())", typeof(System.String));
                if ( !PostProgressInc( __seg__, __ctx__, 27 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 27;
            case 27:
                __ctx1__.__strOrderUtcTime = (System.String)Microsoft.XLANGs.Core.Part.XPathLoad(__ctx1__.__orderMsg.part, "string(/*[local-name()='Order' and namespace-uri()='http://BizTalkDateTimeApp.Order']/*[local-name()='UTCTime' and namespace-uri()='http://BizTalkDateTimeApp.Order']/text())", typeof(System.String));
                if ( !PostProgressInc( __seg__, __ctx__, 28 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 28;
            case 28:
                __ctx1__.__strOrderBiztalkTime = (System.String)Microsoft.XLANGs.Core.Part.XPathLoad(__ctx1__.__orderMsg.part, "string(/*[local-name()='Order' and namespace-uri()='http://BizTalkDateTimeApp.Order']/*[local-name()='BizTalkServerTime' and namespace-uri()='http://BizTalkDateTimeApp.Order']/text())", typeof(System.String));
                if ( !PostProgressInc( __seg__, __ctx__, 29 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 29;
            case 29:
                System.Diagnostics.Trace.WriteLine("****** BizTalkDateTimeApp: xpath string value from element ProviderTime = " + __ctx1__.__strOrderProviderTime);
                if ( !PostProgressInc( __seg__, __ctx__, 30 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 30;
            case 30:
                System.Diagnostics.Trace.WriteLine("****** BizTalkDateTimeApp: xpath string value from element UTCTime = " + __ctx1__.__strOrderUtcTime);
                if (__ctx1__ != null)
                    __ctx1__.__strOrderUtcTime = null;
                if ( !PostProgressInc( __seg__, __ctx__, 31 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 31;
            case 31:
                System.Diagnostics.Trace.WriteLine("****** BizTalkDateTimeApp: xpath string value from element BizTalkServerTime = " + __ctx1__.__strOrderBiztalkTime);
                if (__ctx1__ != null)
                    __ctx1__.__strOrderBiztalkTime = null;
                if ( !PostProgressInc( __seg__, __ctx__, 32 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 32;
            case 32:
                __ctx1__.__parsedOrderProviderTime = System.Xml.XmlConvert.ToDateTime(__ctx1__.__strOrderProviderTime, System.Xml.XmlDateTimeSerializationMode.RoundtripKind);
                if ( !PostProgressInc( __seg__, __ctx__, 33 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 33;
            case 33:
                System.Diagnostics.Trace.WriteLine("****** BizTalkDateTimeApp: parsed datetime (roundtrip) parsedOrderProviderTime.Kind | parsedOrderProviderTime.ToString() = " + System.Convert.ToString(__ctx1__.__parsedOrderProviderTime.Kind) + " | " + __ctx1__.__parsedOrderProviderTime.ToString());
                if ( !PostProgressInc( __seg__, __ctx__, 34 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 34;
            case 34:
                __ctx1__.__parsedOrderProviderTime = System.Xml.XmlConvert.ToDateTime(__ctx1__.__strOrderProviderTime, System.Xml.XmlDateTimeSerializationMode.Unspecified);
                if ( !PostProgressInc( __seg__, __ctx__, 35 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 35;
            case 35:
                System.Diagnostics.Trace.WriteLine("****** BizTalkDateTimeApp: parsed datetime (unspecified) parsedOrderProviderTime.Kind | parsedOrderProviderTime.ToString() = " + System.Convert.ToString(__ctx1__.__parsedOrderProviderTime.Kind) + " | " + __ctx1__.__parsedOrderProviderTime.ToString());
                if ( !PostProgressInc( __seg__, __ctx__, 36 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 36;
            case 36:
                __ctx1__.__parsedOrderProviderTime = System.Xml.XmlConvert.ToDateTime(__ctx1__.__strOrderProviderTime, System.Xml.XmlDateTimeSerializationMode.Local);
                if ( !PostProgressInc( __seg__, __ctx__, 37 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 37;
            case 37:
                System.Diagnostics.Trace.WriteLine("****** BizTalkDateTimeApp: parsed datetime (local) parsedOrderProviderTime.Kind | parsedOrderProviderTime.ToString() = " + System.Convert.ToString(__ctx1__.__parsedOrderProviderTime.Kind) + " | " + __ctx1__.__parsedOrderProviderTime.ToString());
                if ( !PostProgressInc( __seg__, __ctx__, 38 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 38;
            case 38:
                __ctx1__.__parsedOrderProviderTime = System.Xml.XmlConvert.ToDateTime(__ctx1__.__strOrderProviderTime, System.Xml.XmlDateTimeSerializationMode.Utc);
                if ( !PostProgressInc( __seg__, __ctx__, 39 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 39;
            case 39:
                System.Diagnostics.Trace.WriteLine("****** BizTalkDateTimeApp: parsed datetime (utc) parsedOrderProviderTime.Kind | parsedOrderProviderTime.ToString() = " + System.Convert.ToString(__ctx1__.__parsedOrderProviderTime.Kind) + " | " + __ctx1__.__parsedOrderProviderTime.ToString());
                if ( !PostProgressInc( __seg__, __ctx__, 40 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 40;
            case 40:
                __ctx1__.__parsedOrderProviderTime = System.Xml.XmlConvert.ToDateTime(__ctx1__.__strOrderProviderTime);
                if ( !PostProgressInc( __seg__, __ctx__, 41 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 41;
            case 41:
                System.Diagnostics.Trace.WriteLine("****** BizTalkDateTimeApp: parsed datetime (obsolete overload - but still used by many!) parsedOrderProviderTime.Kind | parsedOrderProviderTime.ToString() = " + System.Convert.ToString(__ctx1__.__parsedOrderProviderTime.Kind) + " | " + __ctx1__.__parsedOrderProviderTime.ToString());
                if ( !PostProgressInc( __seg__, __ctx__, 42 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 42;
            case 42:
                __ctx1__.__orderProviderDateTimeOffset = new System.DateTimeOffset((System.DateTime)__ctx1__.__orderMsg.part.GetDistinguishedField("ProviderTime"));
                if ( !PostProgressInc( __seg__, __ctx__, 43 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 43;
            case 43:
                System.Diagnostics.Trace.WriteLine("****** BizTalkDateTimeApp: datetimeoffset distinguished field orderProviderDateTimeOffset.Offset | orderProviderDateTimeOffset.ToString() = " + __ctx1__.__orderProviderDateTimeOffset.Offset.ToString() + " | " + __ctx1__.__orderProviderDateTimeOffset.ToString());
                if ( !PostProgressInc( __seg__, __ctx__, 44 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 44;
            case 44:
                __ctx1__.__orderProviderDateTimeOffset = System.Xml.XmlConvert.ToDateTimeOffset(__ctx1__.__strOrderProviderTime);
                if (__ctx1__ != null)
                    __ctx1__.__strOrderProviderTime = null;
                if ( !PostProgressInc( __seg__, __ctx__, 45 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 45;
            case 45:
                System.Diagnostics.Trace.WriteLine("****** BizTalkDateTimeApp: datetimeoffset parsed from Xpath orderProviderDateTimeOffset.Offset | orderProviderDateTimeOffset.ToString(\"f\") = " + __ctx1__.__orderProviderDateTimeOffset.Offset.ToString() + " | " + __ctx1__.__orderProviderDateTimeOffset.ToString("f"));
                if ( !PostProgressInc( __seg__, __ctx__, 46 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 46;
            case 46:
                __ctx1__.__orderProviderTimePromoted = (System.DateTime)__ctx1__.__orderMsg.GetPropertyValueThrows(typeof(BizTalkDateTimeApp.Schemas.OrderDate));
                if (__ctx1__ != null && __ctx1__.__orderMsg != null)
                {
                    __ctx1__.UnrefMessage(__ctx1__.__orderMsg);
                    __ctx1__.__orderMsg = null;
                }
                if ( !PostProgressInc( __seg__, __ctx__, 47 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 47;
            case 47:
                System.Diagnostics.Trace.WriteLine("****** BizTalkDateTimeApp: datetime promoted property orderProviderTimePromoted.Kind | orderProviderTimePromoted.ToString() = " + System.Convert.ToString(__ctx1__.__orderProviderTimePromoted.Kind) + " | " + __ctx1__.__orderProviderTimePromoted.ToString());
                if ( !PostProgressInc( __seg__, __ctx__, 48 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 48;
            case 48:
                if ( !PreProgressInc( __seg__, __ctx__, 49 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                Tracker.FireEvent(__eventLocations[3],__eventData[4],_stateMgrs[1].TrackDataStream );
                if (IsDebugged)
                    return Microsoft.XLANGs.Core.StopConditions.InBreakpoint;
                goto case 49;
            case 49:
                if (!__ctx1__.CleanupAndPrepareToCommit(__seg__))
                    return Microsoft.XLANGs.Core.StopConditions.Blocked;
                if ( !PostProgressInc( __seg__, __ctx__, 50 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                goto case 50;
            case 50:
                if ( !PreProgressInc( __seg__, __ctx__, 51 ) )
                    return Microsoft.XLANGs.Core.StopConditions.Paused;
                __ctx1__.OnCommit();
                goto case 51;
            case 51:
                __seg__.SegmentDone();
                _segments[0].PredecessorDone(this);
                break;
            }
            return Microsoft.XLANGs.Core.StopConditions.Completed;
        }
    }

    [System.SerializableAttribute]
    sealed public class __BizTalkDateTimeApp_Schemas_Order__ : Microsoft.XLANGs.Core.XSDPart
    {
        private static BizTalkDateTimeApp.Schemas.Order _schema = new BizTalkDateTimeApp.Schemas.Order();

        public __BizTalkDateTimeApp_Schemas_Order__(Microsoft.XLANGs.Core.XMessage msg, string name, int index) : base(msg, name, index) { }

        
        #region part reflection support
        public static Microsoft.XLANGs.BaseTypes.SchemaBase PartSchema { get { return (Microsoft.XLANGs.BaseTypes.SchemaBase)_schema; } }
        #endregion // part reflection support
    }

    [Microsoft.XLANGs.BaseTypes.MessageTypeAttribute(
        Microsoft.XLANGs.BaseTypes.EXLangSAccess.ePublic,
        Microsoft.XLANGs.BaseTypes.EXLangSMessageInfo.eThirdKind,
        "BizTalkDateTimeApp.Schemas.Order",
        new System.Type[]{
            typeof(BizTalkDateTimeApp.Schemas.Order)
        },
        new string[]{
            "part"
        },
        new System.Type[]{
            typeof(__BizTalkDateTimeApp_Schemas_Order__)
        },
        0,
        @"http://BizTalkDateTimeApp.Order#Order"
    )]
    [System.SerializableAttribute]
    sealed public class __messagetype_BizTalkDateTimeApp_Schemas_Order : Microsoft.BizTalk.XLANGs.BTXEngine.BTXMessage
    {
        public __BizTalkDateTimeApp_Schemas_Order__ part;

        private void __CreatePartWrappers()
        {
            part = new __BizTalkDateTimeApp_Schemas_Order__(this, "part", 0);
            this.AddPart("part", 0, part);
        }

        public __messagetype_BizTalkDateTimeApp_Schemas_Order(string msgName, Microsoft.XLANGs.Core.Context ctx) : base(msgName, ctx)
        {
            __CreatePartWrappers();
        }
    }

    [Microsoft.XLANGs.BaseTypes.BPELExportableAttribute(false)]
    sealed public class _MODULE_PROXY_ { }
}
